//*****************************************************************************
//
//	CANREGISTER Declaration des MCP2510
//
//*****************************************************************************
#ifndef _CANREG_H_
#define _CANREG_H_

//*****************************************************************************
//	CAN REGISTER DEFINITIONEN 
//*****************************************************************************

//CONFIG
#define CANREG_STAT       0x0E
#define CANREG_CTRL       0x0F
#define CANREG_CNF1       0x2A
#define CANREG_CNF2       0x29
#define CANREG_CNF3       0x28
#define CANREG_CANINTE    0x2B
#define CANREG_CANINTF    0x2C
#define CANREG_EFLG       0x2D
#define CANREG_TEC        0x1C
#define CANREG_REC        0x1D
//TX0
#define CANREG_TXB0CTRL   0x30
#define CANREG_TXB0SIDH   0x31
#define CANREG_TXB0SIDL   0x32
#define CANREG_TXB0EID8   0x33
#define CANREG_TXB0EID0   0x34
#define CANREG_TXB0DLC    0x35
#define CANREG_TXB0D0     0x36
#define CANREG_TXB0D1     0x37
#define CANREG_TXB0D2     0x38
#define CANREG_TXB0D3     0x39
#define CANREG_TXB0D4     0x3A
#define CANREG_TXB0D5     0x3B
#define CANREG_TXB0D6     0x3C
#define CANREG_TXB0D7     0x3D
//TX1
#define CANREG_TXB1CTRL   0x40
#define CANREG_TXB1SIDH   0x41
#define CANREG_TXB1SIDL   0x42
#define CANREG_TXB1EID8   0x43
#define CANREG_TXB1EID0   0x44
#define CANREG_TXB1DLC    0x45
#define CANREG_TXB1D0     0x46
#define CANREG_TXB1D1     0x47
#define CANREG_TXB1D2     0x48
#define CANREG_TXB1D3     0x49
#define CANREG_TXB1D4     0x4A
#define CANREG_TXB1D5     0x4B
#define CANREG_TXB1D6     0x4C
#define CANREG_TXB1D7     0x4D
//TX2
#define CANREG_TXB2CTRL   0x50
#define CANREG_TXB2SIDH   0x51
#define CANREG_TXB2SIDL   0x52
#define CANREG_TXB2EID8   0x53
#define CANREG_TXB2EID0   0x54
#define CANREG_TXB2DLC    0x55
#define CANREG_TXB2D0     0x56
#define CANREG_TXB2D1     0x57
#define CANREG_TXB2D2     0x58
#define CANREG_TXB2D3     0x59
#define CANREG_TXB2D4     0x5A
#define CANREG_TXB2D5     0x5B
#define CANREG_TXB2D6     0x5C
#define CANREG_TXB2D7     0x5D
//RX0
#define CANREG_RXB0CTRL   0x60
#define CANREG_RXB0SIDH   0x61
#define CANREG_RXB0SIDL   0x62
#define CANREG_RXB0EID8   0x63
#define CANREG_RXB0EID0   0x64
#define CANREG_RXB0DLC    0x65
#define CANREG_RXB0D0     0x66
#define CANREG_RXB0D1     0x67
#define CANREG_RXB0D2     0x68
#define CANREG_RXB0D3     0x69
#define CANREG_RXB0D4     0x6A
#define CANREG_RXB0D5     0x6B
#define CANREG_RXB0D6     0x6C
#define CANREG_RXB0D7     0x6D
//RX0 ADRMASKE
#define CANREG_RXM0SIDH   0x20
#define CANREG_RXM0SIDL   0x21
#define CANREG_RXM0EID8   0x22
#define CANREG_RXM0EID0   0x23
//RX0 Filter0
#define CANREG_RXF0SIDH   0x00
#define CANREG_RXF0SIDL   0x01
#define CANREG_RXF0EID8   0x02
#define CANREG_RXF0EID0   0x03
//RX0 Filter1
#define CANREG_RXF1SIDH   0x04
#define CANREG_RXF1SIDL   0x05
#define CANREG_RXF1EID8   0x06
#define CANREG_RXF1EID0   0x07
//RX1
#define CANREG_RXB1CTRL   0x70
#define CANREG_RXB1SIDH   0x71
#define CANREG_RXB1SIDL   0x72
#define CANREG_RXB1EID8   0x73
#define CANREG_RXB1EID0   0x74
#define CANREG_RXB1DLC    0x75
#define CANREG_RXB1D0     0x76
#define CANREG_RXB1D1     0x77
#define CANREG_RXB1D2     0x78
#define CANREG_RXB1D3     0x79
#define CANREG_RXB1D4     0x7A
#define CANREG_RXB1D5     0x7B
#define CANREG_RXB1D6     0x7C
#define CANREG_RXB1D7     0x7D
//RX1 ADRMASKE
#define CANREG_RXM1SIDH   0x24
#define CANREG_RXM1SIDL   0x25
#define CANREG_RXM1EID8   0x26
#define CANREG_RXM1EID0   0x27
//RX1 Filter2
#define CANREG_RXF2SIDH   0x08
#define CANREG_RXF2SIDL   0x09
#define CANREG_RXF2EID8   0x0A
#define CANREG_RXF2EID0   0x0B
//RX1 Filter3
#define CANREG_RXF3SIDH   0x10
#define CANREG_RXF3SIDL   0x11
#define CANREG_RXF3EID8   0x12
#define CANREG_RXF3EID0   0x13
//RX1 Filter4
#define CANREG_RXF4SIDH   0x14
#define CANREG_RXF4SIDL   0x15
#define CANREG_RXF4EID8   0x16
#define CANREG_RXF4EID0   0x17
//RX1 Filter5
#define CANREG_RXF5SIDH   0x18
#define CANREG_RXF5SIDL   0x19
#define CANREG_RXF5EID8   0x1A
#define CANREG_RXF5EID0   0x1B
//RTS PIN
#define CANREG_TXRTSCTRL  0x0D
#define CANREG_BFPCTRL    0x0C


//*****************************************************************************
//	CAN REGISTER BIT DEFINITIONEN  OR MASKE
//*****************************************************************************
//BFPCTRL
#define B0BFM             0x01
#define B1BFM             0x02
#define B0BFE             0x04
#define B1BFE             0x08
#define B0BFS             0x10
#define B1BFS             0x20
//TXRTSCTRL
#define B0RTSM            0x01
#define B1RTSM            0x02
#define B2RTSM            0x04
#define B0RTS             0x08
#define B1RTS             0x10
#define B2RTS             0x20
//CANSTAT
#define ICOD0             0x01
#define ICOD1             0x02
#define ICOD2             0x08
#define OPMOD0            0x20
#define OPMOD1            0x40
#define OPMOD2            0x80
//CANCTRL
#define CLKPRE0           0x01
#define CLKPRE1           0x02
#define CLKEN             0x04
#define ABAT              0x10
#define REQOP0            0x20
#define REQOP1            0x40
#define REQOP2            0x80
//CNF1
#define BRP0              0x01
#define BRP1              0x02
#define BRP2              0x04
#define BRP3              0x08
#define BRP4              0x10
#define BRP5              0x20
#define SJW0              0x40
#define SJW1              0x80
//CNF2
#define PRSEG0            0x01
#define PRSEG1            0x02
#define PRSEG2            0x04
#define PHSEG10           0x08
#define PHSEG11           0x10
#define PHSEG12           0x20
#define SAM               0x40
#define BTLMODE           0x80
//CNF3
#define PHSEG20           0x01
#define PHSEG21           0x02
#define PHSEG22           0x04
#define WAKFIL            0x40
//CANINTE
#define RX0IE             0x01
#define RX1IE             0x02
#define TX0IE             0x04
#define TX1IE             0x08
#define TX2IE             0x10
#define ERRIE             0x20
#define WAKIE             0x40
#define MERRE             0x80
//CANINTF
#define RX0IF             0x01
#define RX1IF             0x02
#define TX0IF             0x04
#define TX1IF             0x08
#define TX2IF             0x10
#define ERRIF             0x20
#define WAKIF             0x40
#define MERRF             0x80
//EFLG
#define EWARN             0x01
#define RXWAR             0x02
#define TXWAR             0x04
#define RXEP              0x08
#define TXEP              0x10
#define TXBO              0x20
#define RX0OVR            0x40
#define RX1OVR            0x80
//TXBnCTRL
#define TXP0              0x01
#define TXP1              0x02
#define TXREQ             0x08
#define TXERR             0x10
#define MLOA              0x20
#define ABTF              0x40
//RXB0CTRL
#define FILHIT0           0x01
#define BUKT              0x04
#define RXRTR             0x08
#define RXM0              0x20
#define RXM1              0x40
//RXB1CTRL
//#define FILHIT0           0x01
#define FILHIT1           0x02
#define FILHIT2           0x04
//#define RXRTR             0x08
//#define RXM0              0x20
#define RSM1              0x40




#endif

