//*****************************************************************************
//
//	LCD-Modul  mit HD74780 Controller 
//
//*****************************************************************************
#include <io8515.h>
#include "lcd.h"
#include "timer.h"


//*****************************************************************************
//	LCD - Init
//  Input:  -	
//	Output:	-
//*****************************************************************************
void lcd_init(void)
{
  DDRC = 0xFF;
  PORTC = 0x00;
  DDRB = 0xFF;
  PORTB = 0x00;
  timer_delay(30);
  lcd_write(INSTRUCTION,FUNCTION_SET);
  timer_delay(10);
  lcd_write(INSTRUCTION,DISPLAY_ON);
  timer_delay(10);
  lcd_write(INSTRUCTION,DISPLAY_CLEAR);
  timer_delay(10);
}


//*****************************************************************************
//	LCD - Byte schreiben
//  Input:  Typ(Befehl/Daten), Byte	
//	Output:	-
//*****************************************************************************
void lcd_write(unsigned char uc_datentyp,unsigned char uc_x)
{
   if (uc_datentyp != INSTRUCTION)
    {
	   PORTB |= 0x01;  //RS = H
	}
	else {
	       PORTB &= 0xFE; //RS = L
		 }
		        
   PORTB &= 0xFD;  //WR = L				
   PORTC = uc_x;   //Daten 
   PORTB |= 0x04;  // E = H
   timer_delay(1);
   PORTB &= 0xFB;  //E = L
   timer_delay(5);
}


//*****************************************************************************
//	LCD - String schreiben
//  Input:  String,Zeile,Startposition	
//	Output:	-
//*****************************************************************************
void lcd_writestr(char * pc_str,unsigned char uc_zeile,unsigned char uc_offset)
{
unsigned char i;

  if (uc_offset > LINECHARS) uc_offset = 0;
  if (uc_zeile == 1)
   {
     lcd_write(INSTRUCTION,FIRST_LINE + uc_offset);
   }

  if (uc_zeile == 2)
   {
     lcd_write(INSTRUCTION,SECOND_LINE + uc_offset);
   }	

  timer_delay(5);
   
  if (uc_zeile < 3)
   {  
     for(i=0; i < LINECHARS;i++)
      {
        if (pc_str[i] =='\0') break;
        lcd_write(DATA,pc_str[i]);
      }			 
   } 		
}

