#ifndef _LCD_H_
#define _LCD_H_

//Zeichen pro Zeile
#define LINECHARS     16
#define DATA	      0x00
#define INSTRUCTION   0x01

//Adr der Zeilen
#define FIRST_LINE    0x80
#define SECOND_LINE   0xC0

//INIT Anzeige
#define FUNCTION_SET  0x38

//Fkt. des Displays, Cursorfkt.
#define DISPLAY_CLEAR 0x01
#define DISPLAY_ON    0x0C
#define DISPLAY_OFF   0x08
#define CURSOR_ON     0x0E
#define CURSOR_BLINK  0x0D
#define RETURN        0x02
//Rueckwaerts schreiben
#define ENTRY_MODE    0x04
//Vorwaerts schreiben
#define ENTRY_OFF     0x06

#define CURSOR_LEFT   0x10
#define CURSOR_RIGHT  0x14
//Schrift nach rechts schieben 
#define LINESHIFT_R   0x1C
#define LINESHIFT_L   0x18

//Grundinitialisierung
void lcd_init(void);
//Byteweise schreiben
void lcd_write(unsigned char uc_datentyp,unsigned char uc_x);
//Strings schreiben
void lcd_writestr(char * pc_str,unsigned char uc_zeile,unsigned char uc_offset);

#endif
