#include <io8535.h>
#include "init.h"
#include "uart.h"
#include "timer.h"
#include "watchdog.h"
#include "lcd.h"
#include "i2cslave.h"
#include "pwm.h"
#include "led.h"


//*****************************************************************************
//	MAIN - Kommandointerpreter
//  Input:  Kommandostring
//	Output:	-
//*****************************************************************************
unsigned char Kommandointerpreter(char * pc_str)
{
char c_offset[4];
unsigned char i, uc_Kommando;

   uc_Kommando = 0;
   switch (pc_str[1])
   {
   case 'C': lcd_write(INSTRUCTION,DISPLAY_CLEAR);
	         uc_Kommando = 1; //Kommando erkannt
             break;  
   case 'D': lcd_write(INSTRUCTION,DISPLAY_ON);  
	         uc_Kommando = 1; //Kommando erkannt
	         break;  
   case 'O': lcd_write(INSTRUCTION,DISPLAY_OFF);
	         uc_Kommando = 1; //Kommando erkannt
	         break;  
   case 'L': c_offset[0] = pc_str[2];
             for(i=0;i < LINECHARS;i++) pc_str[i]=' '; //Leerstring
	  		 pc_str[LINECHARS] = '\0';		
		     switch (c_offset[0])
		     { 
  		     case '1': lcd_writestr(pc_str,1,0);	 
  		               lcd_write(INSTRUCTION,FIRST_LINE);
		               uc_Kommando = 1; //Kommando erkannt
				 	   break;
  		     case '2': lcd_writestr(pc_str,2,0);	 
  		               lcd_write(INSTRUCTION,SECOND_LINE);
   		               uc_Kommando = 1; //Kommando erkannt
				 	   break;				  
			 }  
			 break;
   case 'X': lcd_write(DATA,pc_str[2]);
	         uc_Kommando = 1; //Kommando erkannt
	         break;
	    
   case 'c': lcd_write(INSTRUCTION,CURSOR_ON);  
	         uc_Kommando = 1; //Kommando erkannt
	         break;  
   case 'b': lcd_write(INSTRUCTION,CURSOR_BLINK);  
	         uc_Kommando = 1; //Kommando erkannt
	         break;  
   case 'l': lcd_write(INSTRUCTION,CURSOR_LEFT);  
	         uc_Kommando = 1; //Kommando erkannt
	         break;  
   case 'r': lcd_write(INSTRUCTION,CURSOR_RIGHT);
	         uc_Kommando = 1; //Kommando erkannt
             break;
		    
   case 'E': lcd_write(INSTRUCTION,ENTRY_MODE);  
	         uc_Kommando = 1; //Kommando erkannt
	         break;  
   case 'F': lcd_write(INSTRUCTION,ENTRY_OFF);  
	         uc_Kommando = 1; //Kommando erkannt
	         break;  
   case 'S': if (pc_str[2] == '0') lcd_write(INSTRUCTION,LINESHIFT_R);
 			   else lcd_write(INSTRUCTION,LINESHIFT_L);  
		     uc_Kommando = 1; //Kommando erkannt
		     break;  
   case 'R': lcd_write(INSTRUCTION,RETURN);
	         uc_Kommando = 1; //Kommando erkannt
	         break;  
		  
   case 'T':c_offset[0] = pc_str[3];
	        c_offset[1] = pc_str[4];
			c_offset[2] = '\0';
		    lcd_writestr(pc_str+5,pc_str[2]-0x30,atoi(c_offset) );  
		    uc_Kommando = 1; //Kommando erkannt
		    break;  

   case 'H':c_offset[0] = pc_str[2];
	        c_offset[1] = pc_str[3];
	        c_offset[2] = pc_str[4];
			c_offset[3] = '\0';
		    pwm_lcdhelligkeit(atoi(c_offset));
			uc_Kommando = 1; //Kommando erkannt			
			break;
   case 'P':led_port(pc_str+2);
			uc_Kommando = 1; //Kommando erkannt			
            break;			
   } //switch
		
   return(uc_Kommando);
}


//*****************************************************************************
//	MAIN - Init
//  Input:  -	
//	Output:	-
//*****************************************************************************
void main(void)
{
char c_str[LINECHARS + 8],x;
unsigned char uc_Kommando;

   init();
   timer_init();
   pwm_init();
   UART_INIT();
   lcd_init();
   i2cslave_init();
   watchdog_set(0x05);
   watchdog_enable();
   led_init();
   led_port("00000000");
   
//lcd_writestr("TEST",1,0);	 
//lcd_write(INSTRUCTION,FIRST_LINE);
   
   //Schleife
   while(1)
   {
      uc_Kommando = 0;    //Kommando = false
      watchdog_reset();
	  
	  if (UART_RXTest())  //sind Zeichen eingelaufen ?
	   {
	      UART_RXStr(c_str);
		  uc_Kommando = Kommandointerpreter(c_str); //String auswerten

	      if (uc_Kommando == 1) UART_TXStr("OK");   //Kommando erkannt
	   	   else UART_TXStr("ERROR"); 
	   }
	   
	  if (i2cslave_RXTest())
	   {
	      i2cslave_RXStr(c_str);		  
		  uc_Kommando = Kommandointerpreter(c_str); //String auswerten
	   }

   }
}
