//*****************************************************************************
//
//	Protokoll fuer UART0
//
//*****************************************************************************
#include "uart0.h"
#include "proto0.h"
#include "kommand0.h"
#include <string.h>
#include <stdlib.h>
#include "watchdog.h"

#define STARTKENNUNG 0x24
#define ENDEKENNUNG  0x0d
#define START        0x01
#define ENDE         0x00


char c_str[128];
unsigned char uc_zeichen,uc_uartstatus = 0;


//*****************************************************************************
//	Protokoll - Zeichenauswertung der UART0
//  Input:	-
//	Output:	-
//*****************************************************************************
void receive_uart0(void)
{
unsigned char uc_x;

  uc_x = UART0_RX();

  watchdog_reset();
 
  if (uc_uartstatus == START)
   {
     c_str[uc_zeichen] = uc_x;
	 uc_zeichen++;
   }
  
  if (uc_x == STARTKENNUNG)
   {
      uc_uartstatus = START;
	  uc_zeichen = 0;
   }	  

  watchdog_reset();

  if ((uc_uartstatus = START) && (uc_x == ENDEKENNUNG)) 
   {
      uc_uartstatus = ENDE;
	  if (uc_zeichen > 0) uc_zeichen--;
	  c_str[uc_zeichen] = '\0';
	  Kommandointerpreter(c_str);
   }	    

  watchdog_reset();
}


//*****************************************************************************
//	Protokoll - String ueber UART0 an PC senden
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_UART0(char * pc_str)
{
unsigned char uc_laenge;
char c_start[2] = {STARTKENNUNG,0x00};
char c_ende[3]  = {ENDEKENNUNG,0x00};

  watchdog_reset();

  uc_laenge = strlen(pc_str);
  strcpy(c_str,c_start);
  strcat(c_str,pc_str);
  strcat(c_str,c_ende);

  watchdog_reset();

  UART0_TXStr(c_str);
  strcpy(c_str,""); 

  watchdog_reset();
}


//*****************************************************************************
//	Protokoll - Zahl an PC senden //TEST
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_WertL(unsigned long ul_x)
{
char c_txt[20];

   watchdog_reset();
 
   strcpy(c_txt,"LONG,");
   ltoa(c_txt+5,ul_x,10);
 
   watchdog_reset();
 
   sende_UART0(c_txt);
   
   watchdog_reset();
}


//*****************************************************************************
//	Protokoll - Zahl an PC senden //TEST
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_WertI(unsigned int ui_x)
{
char c_txt[20];

   watchdog_reset();
 
   strcpy(c_txt,"INT,");
   itoa(c_txt+4,ui_x,10);

   watchdog_reset();

   sende_UART0(c_txt);
 
   watchdog_reset();
}


