//*****************************************************************************
//
//	PWM zur Helligkeitssteuerung der LCD-Anzeige
//
//*****************************************************************************
#include <io8535.h>


//*****************************************************************************
//	PWM - Init
//  Input:  -	
//	Output:	-
//*****************************************************************************
void pwm_init(void)
{
   DDRD |= 0x10;  //PWM-Ausgang freischalten
   TCCR1A = 0x21;
   TCCR1B = 0x62;
   TCNT1H = 0;
   TCNT1L = 0;
   OCR1BH = 0x00;
   OCR1BL = 0x20;  //Helligkeitsvorgabewert
}


//*****************************************************************************
//	PWM - Init
//  Input:  Byte 0 = AUS; 256 = volle Helligkeit
//	Output:	-
//*****************************************************************************
void pwm_lcdhelligkeit(unsigned char uc_h)
{
   OCR1BH = 0;
   OCR1BL = 255 - uc_h; 
}

