//*****************************************************************************
//
//	Grundinitialisierung des ATmega
//
//*****************************************************************************

#include <iom128v.h>
#include "watchdog.h"

#define WDR   asm("WDR");

//*****************************************************************************
//	Initialisierung Watchdogtimer
//  Input:	-
//	Output:	-
//*****************************************************************************

void watchdog_set(unsigned char uc_wdt_prescale)
{
 	 WDR;
 	 WDTCR |= (uc_wdt_prescale & 0x07);		   //Vorteiler setzen
}


//*****************************************************************************
//	Einschalten des Watchdogtimers
//  Input:	-
//	Output:	-
//*****************************************************************************

void watchdog_enable(void)
{
     WDR;
	 WDTCR &= 0x07;
	 WDTCR |= 0x08;
}


//*****************************************************************************
//	Ausschalten des Watchdogtimers
//  Input:	-
//	Output:	-
//*****************************************************************************

void watchdog_disable(void)
{
 	 WDTCR |= 0x18;
 	 WDTCR |= 0x08;
	 WDTCR &= 0x07;
}


//*****************************************************************************
//	Ruecksetzen des Watchdogtimers
//  Input:	-
//	Output:	-
//*****************************************************************************

void watchdog_reset(void)
{
     WDR;
}	 


	